"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2020 Alibaba Group Holding Limited. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""
import abc
import collections.abc
import grpc
import grpc.aio
import message_pb2
import typing

_T = typing.TypeVar('_T')

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta):
    ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore
    ...

class EngineServiceStub:
    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    RunStep: grpc.StreamStreamMultiCallable[
        message_pb2.RunStepRequest,
        message_pb2.RunStepResponse,
    ]
    """Drives the graph computation."""
    HeartBeat: grpc.UnaryUnaryMultiCallable[
        message_pb2.HeartBeatRequest,
        message_pb2.HeartBeatResponse,
    ]
    """Heart beat between coordinator and analytical engine"""

class EngineServiceAsyncStub:
    RunStep: grpc.aio.StreamStreamMultiCallable[
        message_pb2.RunStepRequest,
        message_pb2.RunStepResponse,
    ]
    """Drives the graph computation."""
    HeartBeat: grpc.aio.UnaryUnaryMultiCallable[
        message_pb2.HeartBeatRequest,
        message_pb2.HeartBeatResponse,
    ]
    """Heart beat between coordinator and analytical engine"""

class EngineServiceServicer(metaclass=abc.ABCMeta):
    @abc.abstractmethod
    def RunStep(
        self,
        request_iterator: _MaybeAsyncIterator[message_pb2.RunStepRequest],
        context: _ServicerContext,
    ) -> typing.Union[collections.abc.Iterator[message_pb2.RunStepResponse], collections.abc.AsyncIterator[message_pb2.RunStepResponse]]:
        """Drives the graph computation."""
    @abc.abstractmethod
    def HeartBeat(
        self,
        request: message_pb2.HeartBeatRequest,
        context: _ServicerContext,
    ) -> typing.Union[message_pb2.HeartBeatResponse, collections.abc.Awaitable[message_pb2.HeartBeatResponse]]:
        """Heart beat between coordinator and analytical engine"""

def add_EngineServiceServicer_to_server(servicer: EngineServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
